---
title: ReadableStreamDefaultController.close()
slug: Web/API/ReadableStreamDefaultController/close
tags:
  - API
  - Method
  - ReadableStreamDefaultController
  - Reference
  - Streams
  - close
---
<div>{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>close()</code></strong> method of the {{domxref("ReadableStreamDefaultController")}} interface closes the associated stream.</p>

<div>
<p>Readers will still be able to read any previously-enqueued chunks from the stream, but once those are read, the stream will become closed. If you want to completely get rid of the stream and discard any enqueued chunks, you'd use {{domxref("ReadableStream.cancel()")}} or {{domxref("ReadableStreamDefaultReader.cancel()")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>readableStreamDefaultController</em>.close();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>TypeError</dt>
 <dd>The source object is not a <code>ReadableStreamDefaultController</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following simple example, a custom <code>ReadableStream</code> is created using a constructor (see our <a href="https://mdn.github.io/dom-examples/streams/simple-random-stream/">Simple random stream example</a> for the full code). The <code>start()</code> function generates a random string of text every second and enqueues it into the stream. A <code>cancel()</code> function is also provided to stop the generation if {{domxref("ReadableStream.cancel()")}} is called for any reason.</p>

<p>When a button is pressed, the generation is stopped, the stream is closed using {{domxref("ReadableStreamDefaultController.close()")}}, and another function is run, which reads the data back out of the stream.</p>

<pre class="brush: js">const stream = new ReadableStream({
  start(controller) {
    interval = setInterval(() =&gt; {
      let string = randomChars();

      // Add the string to the stream
      controller.enqueue(string);

      // show it on the screen
      let listItem = document.createElement('li');
      listItem.textContent = string;
      list1.appendChild(listItem);
    }, 1000);

    button.addEventListener('click', function() {
      clearInterval(interval);
      fetchStream();
      controller.close();
    })
  },
  pull(controller) {
    // We don't really need a pull in this example
  },
  cancel() {
    // This is called if the reader cancels,
    // so we should stop generating strings
    clearInterval(interval);
  }
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#rs-default-controller-close","close()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ReadableStreamDefaultController.close")}}</p>
